unit ufrmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  abfComponents, ComCtrls, StdCtrls, Mask, ToolEdit, ExtCtrls, IniFiles,
  dccbut, Menus, RSCOMdec, ToolWin, ImgList, ShellApi;


type
  DCFState = record
    SyncCount: integer;
    Error: integer;
  end;

type
  TfrmMain = class(TForm)
    stiMain: TabfTrayIcon;
    dcCaptionButtonTray: TDCCaptionButton;
    pmSysTray: TPopupMenu;
    pmiMaximize: TMenuItem;
    pmiMinimize: TMenuItem;
    pmiEnd: TMenuItem;
    tiSync: TTimer;
    pcMain: TPageControl;
    tsSet: TTabSheet;
    tsState: TTabSheet;
    lblStart: TLabel;
    lblStop: TLabel;
    dtpStartDate: TDateTimePicker;
    dtpStartTime: TDateTimePicker;
    dtpStopDate: TDateTimePicker;
    dtpStopTime: TDateTimePicker;
    cmdSetStart: TButton;
    cmdSetStop: TButton;
    lblDCF: TLabel;
    lblITC: TLabel;
    lblETC: TLabel;
    pnlDCF: TPanel;
    pnlItc: TPanel;
    pnlETC: TPanel;
    pnlMCU: TPanel;
    Label1: TLabel;
    tbMain: TToolBar;
    tbcmdSet: TToolButton;
    imlMain: TImageList;
    tbcmdInfo: TToolButton;
    pnlNow: TPanel;
    Label2: TLabel;
    spnStartPulse: TUpDown;
    txtStartPulse: TEdit;
    txtStopPulse: TEdit;
    spnStopPulse: TUpDown;
    txtAppDelay: TEdit;
    spnAppDelay: TUpDown;
    lblAppDelay: TLabel;
    tiAppDelay: TTimer;
    chkAppStart: TCheckBox;
    Button1: TButton;
    procedure stiMainDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure dcCaptionButtonTrayClick(Sender: TObject);
    procedure cmdSetStopClick(Sender: TObject);
    procedure cmdSetStartClick(Sender: TObject);
    procedure pmiMaximizeClick(Sender: TObject);
    procedure pmiMinimizeClick(Sender: TObject);
    procedure pmiEndClick(Sender: TObject);
    procedure tiSyncTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure tbcmdSetClick(Sender: TObject);
    procedure tbcmdInfoClick(Sender: TObject);
    procedure txtAppDelayChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure chkAppStartClick(Sender: TObject);
    procedure tiAppDelayTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure SyncPCTime;
    procedure GetMCUDCFState;
    function GetMCUDateTime(var DateTime: TSystemTime; StartChar: integer; StopChar: integer): integer;
    function SetMCUDateTime(DateTime: TSystemTime; StartChar: integer; StopChar: integer): integer;
    function SetMCUPulsLength(const Value: integer): integer;

  end;

var
  frmMain: TfrmMain;
  mDCFTime: TSystemTime;
  mITCTime: TSystemTime;
  mEVTTime: TSystemTime;
  mDCFState: DCFState;
  mIniFile: TIniFile;
  mstrComOpen: string;


implementation

{$R *.DFM}

procedure TfrmMain.stiMainDblClick(Sender: TObject);
begin

  frmMain.show;

end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
  intId: integer;
  ST: TSystemTime;
begin
  mIniFile:=TIniFile.Create(Copy(Application.ExeName, 1, Length(Application.ExeName) - 4) + '.Ini');

  mstrComOpen:=mIniFile.ReadString('Com','Open','');

  dtpStartDate.DateTime:=mIniFile.ReadDateTime('Start','DateTime',Now);
  dtpStartTime.Time:=dtpStartDate.Time;
  spnStartPulse.Position:=mIniFile.ReadInteger('Start','Pulse',3);

  dtpStopDate.DateTime:=mIniFile.ReadDateTime('Stop','DateTime',Now);
  dtpStopTime.Time:=dtpStopDate.Time;
  spnStopPulse.Position:=mIniFile.ReadInteger('Stop','Pulse',3);

  spnAppDelay.Position:=mIniFile.ReadInteger('Application','Delay',30);

  chkAppStart.Checked:=mIniFile.ReadBool('Application','Aktive',false);

  SyncPCTime;

  GetMCUDateTime(mDCFTime,200,201);

  GetMCUDateTime(mEVTTime,204,205);

  for intId:=0 to pcMain.PageCount-1 do
  begin
    pcMain.Pages[intId].TabVisible:=false
  end;

  if (dtpStopDate.DateTime > Now) and chkAppStart.Checked then
  begin
    DateTimeToSystemTime(dtpStopDate.DateTime,ST);
    SetMCUDateTime(ST,206,207); // ETC
    SetMCUPulsLength(spnStopPulse.Position);
  end;

  tiAppDelay.Interval:=spnAppDelay.Position*1000;
  tiAppDelay.Enabled:=chkAppStart.Checked;


  pcMain.ActivePage:=tsSet;
end;

procedure TfrmMain.dcCaptionButtonTrayClick(Sender: TObject);
begin
  stiMain.HideMainForm;
end;

procedure TfrmMain.cmdSetStopClick(Sender: TObject);
begin
  dtpStopDate.Time:=dtpStopTime.Time;
  mIniFile.WriteDateTime('Stop','DateTime',dtpStopDate.DateTime);
  mIniFile.WriteInteger('Stop','Pulse',spnStopPulse.Position);
end;

procedure TfrmMain.cmdSetStartClick(Sender: TObject);
var
  ST:TSystemTime;
begin
  dtpStartDate.Time:=dtpStartTime.Time;
  mIniFile.WriteDateTime('Start','DateTime',dtpStartDate.DateTime);
  mIniFile.WriteInteger('Start','Pulse',spnStartPulse.Position);

  DateTimeToSystemTime(dtpStartDate.DateTime,ST);

  SetMCUDateTime(ST,206,207); // ETC
  SetMCUPulsLength(spnStartPulse.Position);

end;

procedure TfrmMain.pmiMaximizeClick(Sender: TObject);
begin
  stiMain.ShowMainForm;
end;

procedure TfrmMain.pmiMinimizeClick(Sender: TObject);
begin
  stiMain.HideMainForm;
end;

procedure TfrmMain.pmiEndClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.tiSyncTimer(Sender: TObject);
var
  ST: TSystemTime;
begin
//exit;
  pnlNow.Caption:=DateTimeToStr(Now);
  try
    try
      GetMCUDCFState;
      pnlMCU.Caption:='Sync Zhler:' + IntToStr(mDCFState.SyncCount) + ' Error:' + IntToStr(mDCFState.Error); 
      GetMCUDateTime(ST,200,201); //DCF
        if (mDCFState.Error=0) and (mDCFState.SyncCount=0) then
          pnlDCF.Caption:=DateTimeToStr(SystemTimeToDateTime(ST))
        else
          pnlDCF.Caption:='lese Bit:' + IntToStr(ST.wSecond);
    except
      on E: Exception do
        pnlDCF.Caption:='lese Bit:' + IntToStr(ST.wSecond);
    end;
    try
      GetMCUDateTime(ST,202,203); //ITC
      pnlITC.Caption:=DateTimeToStr(SystemTimeToDateTime(ST));
    except
    end;
    try
      GetMCUDateTime(ST,204,205); //ETC
      if ST.wMonth<>255 then
        pnlETC.Caption:=DateTimeToStr(SystemTimeToDateTime(ST))
      else
        pnlETC.Caption:='keine Zeit programmiert';

    except
    end;
  finally
  end;

end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  tiSync.Enabled:=true;
end;

procedure TfrmMain.FormHide(Sender: TObject);
begin
  tiSync.Enabled:=false;
end;

procedure TfrmMain.SyncPCTime;
begin
  GetMCUDCFState;
  if (mDCFState.Error=0) and (mDCFState.SyncCount=0) then
    if GetMCUDateTime(mITCTime,202,203)=0 then
      SetLocalTime(mITCTime);

end;


function TfrmMain.GetMCUDateTime(var DateTime: TSystemTime; StartChar: integer; StopChar: integer): integer;
begin
  if OPENCOM(PChar(mstrComOpen)) <> 0 then
  begin
    SENDBYTE(StartChar);
    if READBYTE = StartChar then
    begin
      DateTime.wYear:=2000+READBYTE;
      DateTime.wMonth:=READBYTE;
      DateTime.wDay:=READBYTE;
      try
        //DateTime.wDayOfWeek:=DayOfWeek(EncodeDate(DateTime.wYear,DateTime.wMonth,DateTime.wDay));
        DateTime.wDayOfWeek:=0;
      except
        on E: Exception do
      end;
      DateTime.wDayOfWeek:=0;
      DateTime.wHour:=READBYTE;
      DateTime.wMinute:=READBYTE;
      DateTime.wSecond:=READBYTE;
      DateTime.wMilliseconds:=0;

      if READBYTE <> StopChar Then
        Result:=1;
    end
    else
    begin
      Result:=2;
    end;
  end
  else
  begin
    ShowMessage('Error Open Com-Port');
  end;
  CLOSECOM;
end;

function TfrmMain.SetMCUDateTime(DateTime: TSystemTime; StartChar,
  StopChar: integer): integer;
begin
  if OPENCOM(PChar(mstrComOpen)) <> 0 then
  begin
    SENDBYTE(StartChar);

    SENDBYTE(DateTime.wYear-2000);
    SENDBYTE(DateTime.wMonth);
    SENDBYTE(DateTime.wDay);
    SENDBYTE(DateTime.wHour);
    SENDBYTE(DateTime.wMinute);
    SENDBYTE(DateTime.wSecond);

    if READBYTE <> StopChar Then
      Result:=1;
  end
  else
  begin
    ShowMessage('Error Open Com-Port');
  end;
  CLOSECOM;
end;

procedure TfrmMain.GetMCUDCFState;
begin
  if OPENCOM(PChar(mstrComOpen)) <> 0 then
  begin
    SENDBYTE(210);
    mDCFState.SyncCount:=READBYTE;
    mDCFState.Error:=READBYTE;
  end;
  CLOSECOM;
end;

procedure TfrmMain.tbcmdSetClick(Sender: TObject);
begin
  pcMain.ActivePage:=tsSet;
end;

procedure TfrmMain.tbcmdInfoClick(Sender: TObject);
begin
  pcMain.ActivePage:=tsState;
end;



procedure TfrmMain.txtAppDelayChange(Sender: TObject);
begin
  mIniFile.WriteInteger('Application','Delay',spnAppDelay.Position);
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  mIniFile.WriteInteger('Application','Delay',spnAppDelay.Position);
end;

procedure TfrmMain.chkAppStartClick(Sender: TObject);
begin
  mIniFile.WriteBool('Application','Aktive',chkAppStart.Checked);
end;

function TfrmMain.SetMCUPulsLength(const Value: integer): integer;
begin
  if OPENCOM(PChar(mstrComOpen)) <> 0 then
  begin
    SENDBYTE(208);
    SENDBYTE(Value);
    READBYTE;
  end;
  CLOSECOM;
end;



procedure TfrmMain.tiAppDelayTimer(Sender: TObject);
var
  strTmp: string;
  hWnd: integer;
begin
  try
    strTmp:=mIniFile.ReadString('Application','ShellExecute','');
    ShellExecute(Handle,'open',PChar(strTmp),'',PChar(ExtractFilePath(strTmp)),0);
    Application.ProcessMessages;
    Sleep(5000);
    Application.ProcessMessages;
    hWnd:=FindWindow('TfrmMain','DVB Viewer');
    PostMessage(hWnd,WM_CLOSE,0,0);
    Application.ProcessMessages;
    sleep(5000);
    Application.ProcessMessages;
    ShellExecute(Handle,'open',PChar(strTmp),'',PChar(ExtractFilePath(strTmp)),0);
    Application.ProcessMessages;
  finally
    tiAppDelay.Enabled:=false;
  end;
end;

procedure TfrmMain.Button1Click(Sender: TObject);
begin
      tiAppDelayTimer(nil);
end;

end.
